package dev.shadowsoffire.apotheosis.advancements;

package .tmp;

import com.google.gson.JsonObject;
import net.minecraft.advancements.critereon.AbstractCriterionTriggerInstance;
import net.minecraft.advancements.critereon.ContextAwarePredicate;
import net.minecraft.advancements.critereon.DeserializationContext;
import net.minecraft.advancements.critereon.EnchantedItemTrigger;
import net.minecraft.advancements.critereon.ItemPredicate;
import net.minecraft.advancements.critereon.MinMaxBounds;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.item.ItemStack;

public class EnchantedTrigger extends EnchantedItemTrigger {
  public Instance createInstance(JsonObject json, ContextAwarePredicate entityPredicate, DeserializationContext conditionsParser) {
    ItemPredicate item = ItemPredicate.m_45051_(json.get("item"));
    MinMaxBounds.Ints levels = MinMaxBounds.Ints.m_55373_(json.get("levels"));
    MinMaxBounds.Doubles eterna = MinMaxBounds.Doubles.m_154791_(json.get("eterna"));
    MinMaxBounds.Doubles quanta = MinMaxBounds.Doubles.m_154791_(json.get("quanta"));
    MinMaxBounds.Doubles arcana = MinMaxBounds.Doubles.m_154791_(json.get("arcana"));
    MinMaxBounds.Doubles rectification = MinMaxBounds.Doubles.m_154791_(json.get("rectification"));
    return new Instance(item, levels, eterna, quanta, arcana, rectification);
  }
  
  public void trigger(ServerPlayer player, ItemStack stack, int level, float eterna, float quanta, float arcana, float rectification) {
    m_66234_(player, inst -> (inst instanceof Instance) ? ((Instance)inst).test(stack, level, eterna, quanta, arcana, rectification) : inst.m_27691_(stack, level));
  }
}
